# Author: sahi
# Website: http://stroyka.in
# Дата: 22.02.2016
# Rezise_group.rb
# Визуално показывает размеры группы или компонента
# :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< :< 
module Sahi
                   
module Rezise

require "sketchup.rb"

class MyRezisegroup<Sketchup::SelectionObserver

   def initialize()
      @select_group = false
      @nomer = Sketchup.version_number
    end
       
   def onSelectionBulkChange(sel) 
     if(sel)
       if(sel[0].kind_of?(Sketchup::ComponentInstance) ||sel[0].kind_of?(Sketchup::Group))
          get_selection_group(sel[0])
        else
          return false
        end
     end   
   end
   
   def start_selection_group(ss = false)
     if(@select_group) then 
       @select_group = false
     	Sketchup.active_model.selection.remove_observer self if(@nomer > 5000260)
     else
       @select_group = true
       Sketchup.active_model.selection.add_observer self if(@nomer > 5000260)
     end
   end 
    
  def get_selection_group(grp)
      if grp
        dept =grp.bounds.depth
        widt =grp.bounds.width
        heigh =grp.bounds.height
        view = Sketchup.active_model.active_view
        view.tooltip = "X- #{dept} Y- #{widt} Z- #{heigh}"
      end
   end
       
  def group_selection
		if(@select_group) then
			return MF_CHECKED
		else
			return MF_UNCHECKED			
		end
	end
  
end
#----------------------------------------------
if( not file_loaded?(File.basename(__FILE__)))
   select_group = Sahi::Rezise::MyRezisegroup.new

   sahi_toolbar_tools = UI::Toolbar.new("Dimensions and Features")
   cmd = UI::Command.new("Dimensions and Features"){ select_group.start_selection_group }
   cmd.tooltip = "Dimensions and Features" 
   cmd.status_bar_text = "Dimensions and Features"
   cmd.large_icon = "./images/group.png"
   cmd.small_icon = "./images/group.png"
   cmd.set_validation_proc{select_group.group_selection}
   sahi_toolbar_tools.add_item cmd
   sahi_toolbar_tools.show
end
#=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=#
end #MySelection
          
end # Sahi
